#include <stdio.h>
#include <svg-cairo.h>

#define RENDER_WIDTH 160
#define RENDER_HEIGHT 40

int main(int argc, char* argv[])
{
   int width, height, i, j;
   svg_cairo_status_t status;
   svg_cairo_t* ctx;
   cairo_t* rend;
   char* data = 0;
   char* pos;

   if (argc < 2)
   {
      printf("no filename\n");
      exit(1);
   }

   status = svg_cairo_create(&ctx);
   status = svg_cairo_parse(ctx, argv[1]);

   rend = cairo_create();
   svg_cairo_get_size(ctx, &width, &height);
   printf("w/h: %d %d\n", width, height);
   data = calloc(1, RENDER_WIDTH*RENDER_HEIGHT*4);
   cairo_scale(rend, (double)(RENDER_WIDTH-2)/(double)width, (double)(RENDER_HEIGHT-2)/(double)height);
   cairo_set_target_image(rend, data, CAIRO_FORMAT_ARGB32, RENDER_WIDTH, RENDER_HEIGHT, RENDER_WIDTH*4);
   status = svg_cairo_render(ctx, rend);
   printf("status: 0x%X\n", status);
   cairo_destroy(rend);

   /* Print out alpha values */
   pos = data;
   for (i = 0; i < RENDER_HEIGHT; i++)
   {
      for (j = 0; j < RENDER_WIDTH; j++)
      {
         printf("%.2X", *(pos+3) & 0xFF);
         pos += 4;
      }

      printf("\n");
   }

   status = svg_cairo_destroy(ctx);
   printf("status: 0x%X\n", status);

   free(data);

   return 0;
}
